/**
 * Bundle of: vue-class-store
 * Generated: 2021-10-18
 * Version: 2.0.6
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
  typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VueClassStore = {}, global.Vue));
})(this, (function (exports, Vue) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

  function makeOptions(model) {
      // prototype
      var prototype = Object.getPrototypeOf(model);
      if (!prototype || prototype === Object.prototype) {
          return {};
      }
      // parent options
      var extendsOptions = makeOptions(prototype);
      // descriptors
      var descriptors = Object.getOwnPropertyDescriptors(prototype);
      // options
      var name = prototype.constructor.name;
      var data = {};
      var computed = {};
      var methods = {};
      var watch = {};
      // data, string watches
      Object.keys(model).forEach(function (key) {
          var value = model[key];
          if (key.startsWith('on:')) {
              watch[key.substring(3)] = value;
          }
          else {
              data[key] = value;
          }
      });
      // function watches, methods, computed
      Object.keys(descriptors).forEach(function (key) {
          if (key !== 'constructor' && !key.startsWith('__')) {
              var ref = descriptors[key];
              var value = ref.value;
              var get = ref.get;
              var set = ref.set;
              if (key.startsWith('on:')) {
                  watch[key.substring(3)] = value;
              }
              else if (value) {
                  methods[key] = value;
              }
              else if (get && set) {
                  computed[key] = { get: get, set: set };
              }
              else if (get) {
                  computed[key] = get;
              }
          }
      });
      // return
      return {
          name: name,
          extends: extendsOptions,
          computed: computed,
          methods: methods,
          watch: watch,
          data: data,
      };
  }
  function makeVue(model) {
      var options = makeOptions(model);
      return new Vue__default["default"](options);
  }
  function VueStore(constructor) {
      function construct() {
          var args = [], len = arguments.length;
          while ( len-- ) args[ len ] = arguments[ len ];

          var instance = new (Function.prototype.bind.apply( constructor, [ null ].concat( args) ));
          return makeVue(instance);
      }
      return construct;
  }
  VueStore.create = makeVue;

  exports["default"] = VueStore;
  exports.makeOptions = makeOptions;
  exports.makeVue = makeVue;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
